package com.example.mapper;

import com.example.entity.Patent;
import com.example.entity.ResearchFiled;
import com.example.entity.Teacher;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface TeacherMapper {
    /**
     * 新增老师基本信息
     * @param
     */
    void saveTeacher(Teacher teacher);

    /**
     * 插入研究领域信息
     * @param researchFiled
     */
    void saveReasearch(@Param("researchFiled") List<ResearchFiled> researchFiled);

    /**
     * 插入专利信息
     * @param patents
     */
    void savePatent(@Param("patents") List<Patent> patents);

    /**
     * 更新老师信息
     * @param teacher
     */
    void updateTeacher(Teacher teacher);

    /**
     * 根据id删除研究领域
     * @param id
     */
    void deleteReasearch(Long id);

    /**
     * 根据id删除专利
     * @param id
     */
    void deletePatents(Long id);
    /**
     * 根据id查询老师研究领域
     * @param id
     */
    @Select("select * from teacherteam_system.research_filed where teacher_id=#{id}")
    List<ResearchFiled> getResearch(Long id);
    /**
     * 根据id查询老师专利
     * @param id
     */
    @Select("select * from teacherteam_system.patent where teacher_id = #{id}")
    List<Patent> getPatent(Long id);
    /**
     * 根据id查询老师基本信息
     * @param id
     */
    @Select("select * from teacherteam_system.teacher where id = #{id}")
    Teacher getTeacher(Long id);

    /**
     * 根据id删除老师信息
     * @param id
     */
    @Delete("delete from teacherteam_system.teacher where id=#{id}")
    void deleteById(Long id);
}
